project "899"                         % This project
include "899glob.pro"                 % Inlcude globals

% 899DBASE.PRO -- Database interface for the WTHS FM project

% GLOBAL PREDICATES FOUND IN THIS MODULE::
%        openbase
%        clbase

PREDICATES
  open_error(INTEGER)   % Does the error routine on open error

CLAUSES
  openbase :-
  	trap(consult(db_file_name),ErrorCode,open_error(ErrorCode)), !.
  openbase :-
  	write("\nProgram Operation Terminated.\n\n"),
  	exit(1).
  
  open_error(ErrorCode) :-
  	write("\n\nERROR (#",ErrorCode,") Reading Data file '",db_file_name,"'"),
  	consulterror(ErrLine,ErrLinePos,ErrFilePos),
  	write("\nLine     :",ErrLine),
  	write("\nPosition :",ErrLinePos),
  	write("\nOffset   :",ErrFilePos),
  	write("\n\nContact Jovo Filipovich IMMEDIATLY, normal operation of"),
  	write("\nthis program CANNOT continue due to errors in the data file.\n").
  
  clbase :-
  	deletefile(db_file_name),
  	save(db_file_name).
  